Unit CaptureUtils;

Interface

Uses
  Windows, DirectShow;

Function FilterName(filter: IBaseFilter): String;
Function PinName(pin: IPin): String;
Function DumpGraph(Graph: IGraphBuilder): String;

Implementation

Uses
  StrUtils;

Const
  Separator = #$0d#$0A;
  Separator1 = #$0d#$0A'--------------------------------------'#$0d#$0A + ' Filtre : ';

Function FilterName(filter: IBaseFilter): String;
Var
  fi: TFilterInfo;
Begin
  If (filter <> Nil) And Succeeded(filter.QueryFilterInfo(fi)) Then
  Begin
    fi.pGraph := Nil;
    Result    := fi.achName;
  End;
End;

Function PinName(pin: IPin): String;
Var
  pi: TPin_Info;
Begin
  If (pin = Nil) Then
    Exit;
  If Succeeded(pin.QueryPinInfo(pi)) Then
  Begin
    Result := FilterName(pi.pFilter) + '.' + pi.achName;
    pi.pFilter := Nil;
  End;
End;

Function DumpGraph(Graph: IGraphBuilder): String;
Var
  filters: IEnumFilters;
  pin, pin1: IPin;
  pins:    IEnumPins;
  filter:  IBaseFilter;
  pd:      TPin_Direction;
Begin
  If (Graph = Nil) Or Failed(Graph.EnumFilters(filters)) Then
    Exit;
  If Succeeded(filters.Reset) Then
    While True Do
    Begin
      If Failed(filters.Next(1, filter, Nil)) Or (filter = Nil) Then
        break;
      // filter info
      Result := Result + Separator + Separator1;
      Result := Result + FilterName(filter) + Separator;

      If Failed(filter.EnumPins(pins)) Or Failed(pins.Reset) Then
        continue;
      While True Do
      Begin
        If Failed(pins.Next(1, pin, Nil)) Or (pin = Nil) Then
          break;

          // pin info
        Result := Result + Separator;
    //      Result:= Result + AddCharR(' ', PinName(pin), 25);

        pin.QueryDirection(pd);
        If pd = PINDIR_INPUT Then
          Result := Result + '<--'#9
        Else
          Result := Result + '-->'#9;
        If Succeeded(pin.ConnectedTo(pin1)) Then
        Begin
          Result := Result + PinName(pin1);
          pin1   := Nil;
        End;

      End;
    End;
End;


End.

