//* Copyright (c) 2009, toutenvrac.org - ouiouioui
//* All rights reserved.
//* Redistribution and use in source and binary forms, with or without
//* modification, are permitted provided that the following conditions are met:
//*
//*     * Redistributions of source code must retain the above copyright
//*       notice, this list of conditions and the following disclaimer.
//*     * Redistributions in binary form must reproduce the above copyright
//*       notice, this list of conditions and the following disclaimer in the
//*       documentation and/or other materials provided with the distribution.
//*     * Neither the name toutenvrac.org, ouiouioui the names of its
//*       contributors may be used to endorse or promote products derived from
//*       this software without specific prior written permission but if you
//*       email at contact@toutenvrac.org for say what you make with it would
//*       be nice.
//*
//* THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND ANY
//* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
//* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
//* DISCLAIMED. IN NO EVENT SHALL THE REGENTS AND CONTRIBUTORS BE LIABLE FOR ANY
//* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
//* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
//* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
//* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
//* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
//* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
Unit MainForm;

Interface

Uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DirectShow, Menus, StdCtrls, ExtCtrls, ComCtrls, Buttons, Mask, VCap, MED,
  WinSkinData, CaptureUtils, ActiveX, GraphConfig, VCapStrings, ShlObj, Jpeg,
  ShellApi, Spin, TCheckDD, DateUtils, rxPlacemnt, rxAnimate, rxGIFCtrl,
  AboutBoxForm;

Type
  TState = Record
    TimeLimit, NbDetect, TimeStarted, TimeNow, TimeLastScreen: Integer;
  End;

  TMain = Class(TForm)
    StatusBar:           TStatusBar;
    pVideo:              TPanel;
    pButtons:            TPanel;
    Video:               TVideoCapture;
    lbDialogs:           TListBox;
    pSettings:           TPanel;
    Timer:               TTimer;
    btMoreSettings:      TButton;
    Button1:             TButton;
    Label3:              TLabel;
    cbVModes:            TComboBox;
    Label4:              TLabel;
    cbAModes:            TComboBox;
    Detection:           TMED;
    ScanMove:            TTimer;
    btSettings:          TBitBtn;
    btCloseSettings:     TButton;
    btClose:             TBitBtn;
    pVideoMaitre:        TPanel;
    pmSelectSize:        TPopupMenu;
    SkinData:            TSkinData;
    FormStorage:         TFormStorage;
    gbCapture:           TGroupBox;
    gbDetect:            TGroupBox;
    btVideo:             TBitBtn;
    btCaptureFrame:      TBitBtn;
    ChangerTailles:      TMenuItem;
    N320X2402:           TMenuItem;
    N480X3602:           TMenuItem;
    N640X4802:           TMenuItem;
    TailleMaximum:       TMenuItem;
    OuvrirDossierImages: TMenuItem;
    OuvrirDossierVideo:  TMenuItem;
    gbDetectMov:         TGroupBox;
    Label1:              TLabel;
    cbViewGridOnScan:    TCheckBox;
    lScannSensibility:   TLabel;
    sbScannSensibility:  TScrollBar;
    cbUseSkin:           TCheckBox;
    cbMinSpace:          TCheckBox;
    seMinSpace:          TSpinEdit;
    Label2:              TLabel;
    Label5:              TLabel;
    Label6:              TLabel;
    seTimeLimit:         TSpinEdit;
    Label7:              TLabel;
    seNbDetect:          TSpinEdit;
    seTimeDetect:        TSpinEdit;
    Label8:              TLabel;
    Label10:             TLabel;
    Label11:             TLabel;
    seImageMaxTime:      TSpinEdit;
    Label9:              TLabel;
    cbScanMode:          TComboBox;
    Memo1:               TMemo;
    ImgRec:              TRxGIFAnimator;
    gbShowFiles:         TGroupBox;
    btShowVideo:         TButton;
    btShowImage:         TButton;
    N1:                  TMenuItem;
    Apropos1:            TMenuItem;
    Quitter1:            TMenuItem;
    Procedure FormShow(Sender: TObject);
    Procedure VideoCaptureProgress(Sender: TObject);
    Procedure btVideoClick(Sender: TObject);
    Procedure btCaptureFrameClick(Sender: TObject);
    Procedure FormClose(Sender: TObject; Var Action: TCloseAction);
    Procedure VideoChangeDevice(Sender: TObject);
    Procedure cbVModesChange(Sender: TObject);
    Procedure cbAModesChange(Sender: TObject);
    Procedure lbDialogsDblClick(Sender: TObject);
    Procedure VideoStartPreview(Sender: TObject);
    Procedure TimerTimer(Sender: TObject);
    Procedure Button1Click(Sender: TObject);
    Procedure FormStorageRestorePlacement(Sender: TObject);
    Procedure FormStorageSavePlacement(Sender: TObject);
    Procedure FormCreate(Sender: TObject);
    Procedure FormDestroy(Sender: TObject);
    Procedure btMoreSettingsClick(Sender: TObject);
    Procedure VideoBitmapGrabbed(CapturedImage: TCapturedBitmap);
    Procedure ScanMoveTimer(Sender: TObject);
    Procedure FormResize(Sender: TObject);
    Procedure btSettingsClick(Sender: TObject);
    Procedure btCloseSettingsClick(Sender: TObject);
    Procedure btCloseClick(Sender: TObject);
    Procedure FormCanResize(Sender: TObject; Var NewWidth, NewHeight: Integer; Var Resize: Boolean);
    Procedure N640X4801Click(Sender: TObject);
    Procedure N320X2401Click(Sender: TObject);
    Procedure FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    Procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    Procedure FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    Procedure Maximum1Click(Sender: TObject);
    Procedure N480X3601Click(Sender: TObject);
    Procedure OuvrirDossierImagesClick(Sender: TObject);
    Procedure OuvrirDossierVideoClick(Sender: TObject);
    Procedure cbViewGridOnScanClick(Sender: TObject);
    Procedure sbScannSensibilityChange(Sender: TObject);
    Procedure cbUseSkinClick(Sender: TObject);
    Procedure cbMinSpaceClick(Sender: TObject);
//    Procedure VideoDetectionMotion(Sender: TObject);
    Procedure DetectionMotion(Sender: TObject);
    Procedure seTimeDetectChange(Sender: TObject);
    Procedure seNbDetectChange(Sender: TObject);
    Procedure cbScanModeChange(Sender: TObject);
    Procedure cbScanModeEnter(Sender: TObject);
    Procedure Memo1DblClick(Sender: TObject);
    Procedure Quitter1Click(Sender: TObject);
    procedure Apropos1Click(Sender: TObject);
  Private
    Config:                             TGraphConfig;
    MakeSingleCapture, PressClick:      Boolean;
    CamName, BaseDir, ImgDir, VideoDir: String;
    LastX, LastY:                       Integer;
    CheckDD:                            TTCheckDD;
    Scan:                               TState;
    //    Function InitCapture: Boolean;
    Function SpecialFolder(Folder: Integer): String;
    Procedure SetCheckDD;
    Function CheckSpaceDD: Boolean;
    Procedure StartCapt;
    Procedure StopCapt;
    Function CheckCaptPrev: Boolean;
  Public
    Procedure StopAll(Msg, StatusMsg: String);
  End;

Var
  Main: TMain;

Implementation

{$R *.DFM}

Function ApplicationVersion: String;
Var
  VerInfoSize, VerValueSize, Dummy: DWord;
  VerInfo:                          Pointer;
  VerValue:                         PVSFixedFileInfo;
Begin
  VerInfoSize := GetFileVersionInfoSize(PChar(ParamStr(0)), Dummy);
  If VerInfoSize <> 0 Then // Les info de version sont inclues
  Begin
    GetMem(VerInfo, VerInfoSize); // On alloue de la mmoire pour un pointeur sur les info de version
    GetFileVersionInfo(PChar(ParamStr(0)), 0, VerInfoSize, VerInfo); // On rcupre ces informations
    VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize); // On traite les informations ainsi rcupres
    With VerValue^ Do // on formate le rsultat en sparant chaque numro d'un point
    Begin
      Result := IntToStr(dwFileVersionMS Shr 16);
      Result := Result + '.' + IntToStr(dwFileVersionMS And $FFFF);
      Result := Result + '.' + IntToStr(dwFileVersionLS Shr 16);
      Result := Result + '.' + IntToStr(dwFileVersionLS And $FFFF);
    End;
    FreeMem(VerInfo, VerInfoSize); // On libre la place prcdemment alloue
  End
  Else
    Raise EAccessViolation.Create('Les informations de version de sont pas inclues'); // Les infos de version ne sont pas inclues On dclenche une exception dans le programme
End;

Function ApplicationVersionBuild: String;
Var
  PointBuild: Integer;
  AppVer:     String;
Begin
  Result     := '';
  AppVer     := ApplicationVersion;
  PointBuild := LastDelimiter('.', AppVer);
  Result     := 'Version ' + Copy(AppVer, 0, PointBuild - 1) + ' Build: ' + Copy(AppVer, PointBuild + 1, Length(AppVer));
End;

Function TMain.SpecialFolder(Folder: Integer): String;
Var
  SFolder:     pItemIDList;
  SpecialPath: Array[0..MAX_PATH] Of Char;
Begin
  SHGetSpecialFolderLocation(Main.Handle, Folder, SFolder);
  SHGetPathFromIDList(SFolder, SpecialPath);
  Result := StrPas(SpecialPath);
End;

//Function TMain.InitCapture: Boolean;
//Begin
//  Result := Video.Init;
//End;

Function TMain.CheckSpaceDD: Boolean;
Var
  FreeAvailable, TotalSpace: TLargeInteger;
Begin
  //- check space restant min is space
  If Not DirectoryExists(ImgDir) Then
    ForceDirectories(ImgDir);
  If Not DirectoryExists(VideoDir) Then
    ForceDirectories(VideoDir);
  If cbMinSpace.Checked Then
  Begin
    GetDiskFreeSpaceEx(PChar(BaseDir), FreeAvailable, TotalSpace, NIL);
    FreeAvailable := FreeAvailable Div 1024 Div 1024 Div 1024;
    TotalSpace    := TotalSpace Div 1024 Div 1024 Div 1024;
    If FreeAvailable < seMinSpace.Value Then
    Begin
      //    Stopall('Espace disque insuffisant il reste ' + IntToStr(FreeAvailable) + ' sur ' + IntToStr(TotalSpace) + ' Goc');
      StatusBar.SimpleText := 'Espace disque insuffisant il reste ' + IntToStr(FreeAvailable) + ' sur ' + IntToStr(TotalSpace) + ' Go';
      MessageDlg('Espace disque insuffisant il reste ' + IntToStr(FreeAvailable) + 'Go sur ' + IntToStr(TotalSpace) + 'Go' + sLineBreak +
        'Vous devez librer de la place si vous voulez' + sLineBreak +
        'enregistrer de nouvelles images et/ou vidos.', mtError, [mbOK], 0);
      Result := False;
    End
    Else
      Result := True;
  End
  Else
    Result := True;
End;

Procedure TMain.DetectionMotion(Sender: TObject);
Begin
  If Not CheckSpaceDD Then
    Exit;
  //  Scan.NbDetect := 0;
  Scan.TimeNow := DateTimeToUnix(now);
  If (Scan.TimeNow > (Scan.TimeStarted + seTimeDetect.Value)) Then
  Begin
    {$IFDEF DEBUG}
    memo1.Lines.Add('1-Scan.TimeLimit=' + IntToStr(Scan.TimeLimit));
    memo1.Lines.Add('1-Scan.TimeStarted=' + IntToStr(Scan.TimeStarted) + ' Scan.TimeNow=' + IntToStr(Scan.TimeNow));
    {$ENDIF}
    Scan.TimeStarted := Scan.TimeNow;
    Scan.NbDetect    := 1;
  End
  Else
  If (Scan.NbDetect < seNbDetect.Value) Then
  Begin
    {$IFDEF DEBUG}
    memo1.Lines.Add('2-Scan.TimeLimit=' + IntToStr(Scan.TimeLimit));
    memo1.Lines.Add('2-Scan.NbDetect=' + IntToStr(Scan.NbDetect) + ' seNbDetect.Value=' + IntToStr(seNbDetect.Value));
    {$ENDIF}
    Inc(Scan.NbDetect);
  End
  Else
  If Scan.NbDetect = seNbDetect.Value Then
  Begin
    Scan.TimeLimit   := seTimeLimit.Value * 10;
    Scan.TimeStarted := Scan.TimeStarted - seTimeDetect.Value;
    If (cbScanMode.ItemIndex = 1) And (Not Video.Capturing) Then
      StartCapt
    Else
    If (cbScanMode.ItemIndex = 2) And (Scan.TimeLastScreen <= (Scan.TimeNow - seImageMaxTime.Value)) Then
    Begin
      Scan.TimeLastScreen := Scan.TimeNow;
      MakeSingleCapture   := True;
      Video.CaptureFrame;
      {$IFDEF DEBUG}
      memo1.Lines.Add('3-Scan.TimeLastScreen=' + IntToStr(Scan.TimeLastScreen) + ' Scan.TimeNow-seImageMaxTime=' + IntToStr((Scan.TimeNow - seImageMaxTime.Value)));
      memo1.Lines.Add('3-add temps');
      {$ENDIF}
    End;
  End;
End;

//Procedure TMain.VideoDetectionMotion(Sender: TObject);
//Begin
//  If Not CheckSpaceDD Then
//    Exit;
//  //  Scan.NbDetect := 0;
//  Scan.TimeNow := DateTimeToUnix(now);
//  If (Scan.TimeNow > (Scan.TimeStarted + seTimeDetect.Value)) Then
//  Begin
//    {$IFDEF DEBUG}
//    memo1.Lines.Add('1-Scan.TimeLimit=' + IntToStr(Scan.TimeLimit));
//    memo1.Lines.Add('1-Scan.TimeStarted=' + IntToStr(Scan.TimeStarted) + ' Scan.TimeNow=' + IntToStr(Scan.TimeNow));
//    {$ENDIF}
//    Scan.TimeStarted := Scan.TimeNow;
//    Scan.NbDetect := 1;
//  End
//  Else
//  If (Scan.NbDetect < seNbDetect.Value) Then
//  Begin
//    {$IFDEF DEBUG}
//    memo1.Lines.Add('2-Scan.TimeLimit=' + IntToStr(Scan.TimeLimit));
//    memo1.Lines.Add('2-Scan.NbDetect=' + IntToStr(Scan.NbDetect) + ' seNbDetect.Value=' + IntToStr(seNbDetect.Value));
//    {$ENDIF}
//    Inc(Scan.NbDetect);
//  End
//  Else
//  If Scan.NbDetect = seNbDetect.Value Then
//  Begin
//    Scan.TimeLimit := seTimeLimit.Value * 10;
//    Scan.TimeStarted := Scan.TimeStarted - seTimeDetect.Value;
//    If Not Video.Capturing Then
//      StartCapt;
//    {$IFDEF DEBUG}
//    memo1.Lines.Add('3-Scan.TimeLimit=' + IntToStr(Scan.TimeLimit));
//    memo1.Lines.Add('3-add temps');
//    {$ENDIF}
//  End;
//End;

Procedure TMain.FormShow(Sender: TObject);
Begin
  //  if not InitCapture then begin
  //    ShowMessage('Can''t init capture!');
  //    Application.Terminate;
  //  end;
  Detection.Visible     := False;
  seNbDetect.OnChange   := seNbDetectChange;
  seTimeDetect.OnChange := seTimeDetectChange;
End;

Procedure TMain.VideoCaptureProgress(Sender: TObject);
Begin
  //  StatusBar.SimpleText := IntToStr(timelimit);
  StatusBar.SimpleText := 'Temps d''enregistrement: ' + TimeToStr((Video.CapTime Div 1000) / 24 / 3600);
  //IntToStr(Video.CapTime) + ' Minutes ' + IntToStr(Video.CapTime Div 1000) + ' Secondes.';
  If cbScanMode.ItemIndex <> 0 Then
    If Scan.TimeLimit > 0 Then
      Dec(Scan.TimeLimit)
    Else
      StopCapt;
End;

Procedure TMain.StartCapt;
Begin
  Video.StartCapture(False);
  btVideo.Caption := 'Arrter';
  ImgRec.Visible  := True;
  ImgRec.Animate  := True;
End;

Procedure TMain.StopCapt;
Var
  NameFile: String;
Begin
  Scan.TimeLimit       := 0;
  Scan.NbDetect        := 1;
  Scan.TimeStarted     := DateTimeToUnix(now);
  Scan.TimeLastScreen  := 0;
  StatusBar.SimpleText := 'Patientez...';
  NameFile             := FormatDateTime('yyyy-mm-dd - hh-nn-ss', Now) + '.avi';
  Video.StopCapture(VideoDir + NameFile);
  StatusBar.SimpleText := 'Vido ' + NameFile + ' enregist.';
  btVideo.Caption      := 'Vido';
  ImgRec.Visible       := False;
  ImgRec.Animate       := False;
End;

Procedure TMain.btVideoClick(Sender: TObject);
Begin
  If Not CheckCaptPrev Then
    Exit;
  If Not CheckSpaceDD Then
    Exit;
  btVideo.Enabled := False;
  If Video.Capturing Then
    StopCapt
  Else
  Begin
    If cbScanMode.ItemIndex <> 0 Then
    Begin
      cbScanMode.ItemIndex := 0;
      cbScanModeChange(cbScanMode);
    End;
    StartCapt;
  End;
  btVideo.Enabled := True;
End;

Procedure TMain.btSettingsClick(Sender: TObject);
Begin
  If pSettings.Visible Then
    pSettings.Visible := False
  Else
    pSettings.Visible := True;
End;

procedure TMain.Apropos1Click(Sender: TObject);
begin
  with TAboutBox.Create(nil) do
  begin
    try
      lVersion.Caption := ApplicationVersionBuild;
      ShowModal;
    finally
      Free;
    end;
  end;
end;

Procedure TMain.btCaptureFrameClick(Sender: TObject);
Begin
  If Not CheckSpaceDD Then
    Exit;
  If Not CheckCaptPrev Then
    Exit;
  MakeSingleCapture := True;
  If Not Video.CaptureFrame Then
    ShowMessage('Enregistrement chou.');
End;

Procedure TMain.btCloseClick(Sender: TObject);
Begin
  btClose.Enabled := False;
  Close;
End;

Procedure TMain.FormCanResize(Sender: TObject; Var NewWidth, NewHeight: Integer; Var Resize: Boolean);
Begin
  If NewHeight < 297 Then
    NewHeight := 297;
  If NewWidth < 421 Then
    NewWidth := 421;
End;

Procedure TMain.FormClose(Sender: TObject; Var Action: TCloseAction);
Begin
  Video.StopCapture(VideoDir + FormatDateTime('yyyy-mm-dd - hh-nn-ss', Now) + '.avi');
  Video.StopPreview;
End;

Procedure TMain.VideoChangeDevice(Sender: TObject);
Var
  i, capCount:         Integer;
  cvcapMode, vcapMode: TVCapMode;
  cacapMode, acapMode: TACapMode;
  s:                   String;
  d:                   TCaptureDialog;
Begin
  cvcapMode := Video.VCapMode;
  cacapMode := Video.ACapMode;

  cbVModes.Items.Clear;
  capCount := Video.VCapModeCount;
  For i := 0 To capCount - 1 Do
  Begin
    vcapMode := Video.VCapModes[i];
    s        := GetModeString(vcapMode);
    cbVModes.Items.Add(s);
    If IsEqualModes(cvcapMode, vcapMode) Then
      cbVModes.ItemIndex := i;
  End;

  cbAModes.Items.Clear;
  capCount := Video.ACapModeCount;
  For i := 0 To capCount - 1 Do
  Begin
    acapMode := Video.ACapModes[i];
    s        := GetModeString(acapMode);
    cbAModes.Items.Add(s);
    If IsEqualModes(cacapMode, acapMode) Then
      cbAModes.ItemIndex := i;
  End;

  lbDialogs.Items.Clear;
  For d := Low(TCaptureDialog) To High(TCaptureDialog) Do
    If d In Video.Dialogs Then
      lbDialogs.Items.AddObject(DialogTitles[d], TObject(d));
End;

Procedure TMain.VideoStartPreview(Sender: TObject);
Begin
  // refresh cur modes
  cbVModes.ItemIndex := Video.VCapModeIdx;
  cbAModes.ItemIndex := Video.VCapModeIdx;
  //lbFrames.Caption:= '';
End;

Procedure TMain.cbVModesChange(Sender: TObject);
Begin
  Video.SetVCapMode(cbVModes.ItemIndex);
  Video.StartPreview;
End;

Procedure TMain.cbUseSkinClick(Sender: TObject);
Begin
  SkinData.Active := (Sender As TCheckBox).Checked;
End;

Procedure TMain.cbViewGridOnScanClick(Sender: TObject);
Begin
  If (Sender As TCheckBox).Checked Then
  Begin
    Detection.ShowItem := [shiGrid, shiDetectedCell];
    If ScanMove.Enabled Then
      Detection.Visible := True;
  End
  Else
  Begin
    Detection.ShowItem := [];
    If ScanMove.Enabled Then
      Detection.Visible := False;
  End;
End;

Procedure TMain.cbAModesChange(Sender: TObject);
Begin
  Video.SetACapMode(cbAModes.ItemIndex);
  Video.StartPreview;
End;

Procedure TMain.cbMinSpaceClick(Sender: TObject);
Begin
  // SetCheckDD;
  seMinSpace.Enabled := (Sender As TCheckBox).Checked;
End;

Procedure TMain.cbScanModeChange(Sender: TObject);
Begin
  If (Sender As TComboBox).ItemIndex < 1 Then
  Begin
    ScanMove.Enabled := False;
    If Detection.Visible Then
      Detection.Visible := False;
    If Video.Capturing Then
      StopCapt;
  End
  Else
  If ((Sender As TComboBox).ItemIndex = 1) Or ((Sender As TComboBox).ItemIndex = 2) Then
  Begin
    If {CheckSpaceDD And (}video.Previewing Or Video.Capturing{)} Then
    Begin
      If ScanMove.Enabled Then
        ScanMove.Enabled := False;
      Scan.TimeLimit := 0;
      Scan.NbDetect       := 1;
      Scan.TimeStarted    := DateTimeToUnix(now);
      Scan.TimeLastScreen := 0;
    //set to detection.onmotion and onnotmotion the good procedure before active scann
    //      If (Sender As TComboBox).ItemIndex = 1 Then
    //        Detection.OnMotion := VideoDetectionMotion
    //      Else
    //        Detection.OnMotion := ImageDetectionMotion;
      ScanMove.Enabled    := True;
      If Detection.ShowItem <> [] Then
        Detection.Visible := True;
    End;
  End;
End;

Procedure TMain.cbScanModeEnter(Sender: TObject);
Begin
  If Not CheckCaptPrev Then
    Exit;
  If Not CheckSpaceDD Then
    gbDetect.SetFocus;
End;

Function TMain.CheckCaptPrev: Boolean;
Begin
  If (Not Video.Previewing) And (Not Video.Capturing) Then
  Begin
    Messagedlg('Aucune vido n''est affich, cette action est impossible', mtWarning, [mbOK], 0);
    gbDetect.SetFocus;
    Result := False;
  End
  Else
    Result := True;
End;

Procedure TMain.lbDialogsDblClick(Sender: TObject);
Begin
  If (lbDialogs.Items.Count > 0) And (lbDialogs.ItemIndex >= 0) Then
    Video.ShowDialog(TCaptureDialog(lbDialogs.Items.Objects[lbDialogs.ItemIndex]));
End;

Procedure TMain.Maximum1Click(Sender: TObject);
Begin
  If Main.WindowState <> wsMaximized Then
    Main.WindowState := wsMaximized
  Else
    Main.WindowState := wsNormal;
End;

Procedure TMain.Memo1DblClick(Sender: TObject);
Begin
  If memo1.Height <> 10 Then
    memo1.Height := 10
  Else
    memo1.Height := 232;
End;

Procedure TMain.N320X2401Click(Sender: TObject);
Begin
  If Main.WindowState <> wsNormal Then
    Main.WindowState := wsNormal;
  Width := 421;
  Height := 297;
End;

Procedure TMain.N480X3601Click(Sender: TObject);
Begin
  If Main.WindowState <> wsNormal Then
    Main.WindowState := wsNormal;
  Width := 581;
  Height := 417;
End;

Procedure TMain.N640X4801Click(Sender: TObject);
Begin
  If Main.WindowState <> wsNormal Then
    Main.WindowState := wsNormal;
  Width := 741;
  Height := 537;
End;

Procedure TMain.OuvrirDossierImagesClick(Sender: TObject);
Begin
  ShellExecute(Handle, 'explore', PChar(ImgDir), NIL, NIL, SW_SHOWMAXIMIZED);
End;

Procedure TMain.OuvrirDossierVideoClick(Sender: TObject);
Begin
  ShellExecute(Handle, 'explore', PChar(VideoDir), NIL, NIL, SW_SHOWMAXIMIZED);
End;

Procedure TMain.Quitter1Click(Sender: TObject);
Begin
  btCloseClick(Sender);
End;

Procedure TMain.ScanMoveTimer(Sender: TObject);
Begin
  Video.CaptureFrame;
End;

Procedure TMain.seNbDetectChange(Sender: TObject);
Var
  MinValue: Extended;
Begin
  MinValue := seNbDetect.Value / 3;
  If seTimeDetect.Value < MinValue Then
    seTimeDetect.Value := seTimeDetect.Value + 1;
End;

Procedure TMain.StopAll(Msg, StatusMsg: String);
Var
  ActionSet: Boolean;
Begin
  ActionSet := False;
  //  If Not rbScanStop.Checked Then
  //  Begin
  //    rbScanVideo.Checked := False;
  //    rbScanStop.Checked := True;
  //    rbScanStopClick(rbScanStop);
  //    ActionSet := True;
  //  End;
  If cbScanMode.ItemIndex <> 0 Then
  Begin
    cbScanMode.ItemIndex := 0;
    cbScanModeChange(cbScanMode);
    ActionSet := True;
  End;
  If Video.Capturing Then
  Begin
    StopCapt;
    ActionSet := True;
  End;
  If ActionSet Then
  Begin
    StatusBar.SimpleText := StatusMsg;
    MessageDlg(Msg, mtError, [mbOK], 0);
  End;
End;

Procedure TMain.SetCheckDD;
Begin
  If Assigned(CheckDD) Then
    CheckDD.Terminate;
  If cbMinSpace.Checked Then
    CheckDD := TTCheckDD.Create(seMinSpace.Value, BaseDir);
End;

Procedure TMain.seTimeDetectChange(Sender: TObject);
Var
  MaxValue: Integer;
Begin
  //  seNbDetect.MinValue := seTimeDetect.Value;
  //  seNbDetect.MaxValue := seTimeDetect.Value * 3;
  //  if seNbDetect.Value < seNbDetect.MinValue then seNbDetect.Value := seNbDetect.MinValue
  MaxValue := seTimeDetect.Value * 3;
  If seNbDetect.Value > MaxValue Then
    seNbDetect.Value := MaxValue;
End;

Procedure TMain.sbScannSensibilityChange(Sender: TObject);
Begin
  lScannSensibility.Caption   := IntToStr(sbScannSensibility.Position);
  Detection.GlobalSensitivity := sbScannSensibility.Position;
End;

Procedure TMain.TimerTimer(Sender: TObject);
Begin
  // make a delay to show form (let form get a handle)
  Timer.Enabled := False;
  //  StartWait;
  Try
    Video.RestoreGraph(Config);
    //    If rbScanImage.Checked Then
    //      rbScanImageClick(rbScanImage)
    //    Else
    //    If rbScanVideo.Checked Then
    //      rbScanVideoClick(rbScanVideo);
    cbScanModeChange(cbScanMode);
  Finally
    //  StopWait;
  End;
End;

Procedure TMain.Button1Click(Sender: TObject);
Var
  s: TStringList;
  x: IXml2Dex;
Begin
  If (Video.CaptureGraph = NIL) Then
    Exit;
  s := TStringList.Create;
  Try
    s.Text := DumpGraph(Video.CaptureGraph);
    s.SaveToFile('graph.txt');
  Finally
    s.Free;
  End;
  If Succeeded(CoCreateInstance(CLSID_Xml2Dex, NIL, CLSCTX_INPROC, IID_IXml2Dex, x)) Then
    x.WriteGrfFile(Video.CaptureGraph, 'graph.grf');
End;

Procedure TMain.FormStorageRestorePlacement(Sender: TObject);
Var
  S: String;
Begin
  Try
    S := FormStorage.IniFile.ReadString('Graph', 'Config', '');
    If S <> '' Then
      Config.RestoreGraph(s);
  Except
  End;
  Try
    //    cbViewGridOnScan.Checked := FormStorage.IniFile.ReadBool('Settings', 'cbViewGridOnScan', False);
    cbViewGridOnScanClick(cbViewGridOnScan);
    //    sbScannSensibility.Position := FormStorage.IniFile.ReadInteger('Settings', 'sbScannSensibility', 5);
    sbScannSensibilityChange(sbScannSensibility);
    //    cbUseSkin.Checked := FormStorage.IniFile.ReadBool('Settings', 'cbUseSkin', True);
    cbUseSkinClick(cbUseSkin);
    //    cbMinSpace.Checked := FormStorage.IniFile.ReadBool('Settings', 'cbMinSpace', False);
    //    seMinSpace.Value := FormStorage.IniFile.ReadInteger('Settings', 'seMinSpace', 10);
    SetCheckDD;
  Except
  End;
  Timer.Enabled := S <> '';
End;

Procedure TMain.FormStorageSavePlacement(Sender: TObject);
Begin
  If Config.VCapSource <> '' Then
  Begin
    Video.SaveGraph(Config);
    Try
      FormStorage.IniFile.WriteString('Graph', 'Config', Config.SaveGraph);
    Except
    End;
  End;
  Try
    //    FormStorage.IniFile.WriteBool('Settings', 'cbViewGridOnScan', cbViewGridOnScan.Checked);
    //    FormStorage.IniFile.WriteInteger('Settings', 'sbScannSensibility', sbScannSensibility.Position);
    //    FormStorage.IniFile.WriteBool('Settings', 'cbUseSkin', cbUseSkin.Checked);
    //    FormStorage.IniFile.WriteBool('Settings', 'cbMinSpace', cbMinSpace.Checked);
    //    FormStorage.IniFile.WriteInteger('Settings', 'seMinSpace', seMinSpace.Value);
    If Assigned(CheckDD) Then
      CheckDD.Terminate;
  Except
  End;
End;

Procedure TMain.FormCreate(Sender: TObject);
Begin
  FormStorage.IniFileName   := ChangeFileExt(Application.ExeName, '.ini');
  Config                    := TGraphConfig.Create;
  MakeSingleCapture         := False;
  CamName                   := ChangeFileExt(ExtractFileName(Application.ExeName), '');
  Caption                   := CamName;
  PressClick                := False;
  LastX                     := 0;
  LastY                     := 0;
  Scan.TimeLimit            := 0;
  Scan.NbDetect             := 1;
  Scan.TimeLastScreen       := 0;
  Scan.TimeStarted          := DateTimeToUnix(now);
  Video.CaptureFileName     := 'cature' + CamName + '.avi';
  Video.TempCaptureFileName := 'temp' + CamName + '.avi';
  BaseDir                   := SpecialFolder(CSIDL_PERSONAL) + '\';
  ImgDir                    := BaseDir + 'Mes images\' + CamName + '\';
  VideoDir                  := BaseDir + 'Mes vidos\' + CamName + '\';
  //  If Not DirectoryExists(BaseDir + 'Mes images') Then
  //    CreateDir(BaseDir + 'Mes images');
  //  If Not DirectoryExists(BaseDir + 'Mes vidos') Then
  //    CreateDir(BaseDir + 'Mes vidos');
  If Not DirectoryExists(ImgDir) Then
    ForceDirectories(ImgDir);
  If Not DirectoryExists(VideoDir) Then
    ForceDirectories(VideoDir);
  Detection.OnMouseMove := FormMouseMove;
  Detection.OnMouseUp   := FormMouseUp;
  Detection.OnMouseDown := FormMouseDown;
  {$IFDEF DEBUG}
  Memo1.Visible         := True;
  {$ENDIF}
End;

Procedure TMain.FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Begin
  PressClick := False;
End;

Procedure TMain.FormMouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Begin
  PressClick := True;
  LastX      := X;
  LastY      := Y;
End;

Procedure TMain.FormMouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
Begin
  If PressClick Then
  Begin
    Left := Left + (X - LastX);
    Top  := Top + (Y - LastY);
  End;
End;

Procedure TMain.FormDestroy(Sender: TObject);
Begin
  Config.Free;
End;

Procedure TMain.FormResize(Sender: TObject);
Var
  NewWidth, NewHeight: Extended;
  WidthOk, HeightOk:   Integer;
Begin
  If (pVideoMaitre.Width / pVideoMaitre.Height) < 1.3333333333333333333333333333333 Then
  Begin
    NewWidth  := pVideoMaitre.Width;
    NewHeight := pVideoMaitre.Width / 1.3333333333333333333333333333333;
  End
  Else
  If (pVideoMaitre.Width / pVideoMaitre.Height) > 1.3333333333333333333333333333333 Then
  Begin
    NewWidth  := pVideoMaitre.Height * 1.3333333333333333333333333333333;
    NewHeight := pVideoMaitre.Height;
  End
  Else
  Begin
    NewWidth  := pVideoMaitre.Width;
    NewHeight := pVideoMaitre.Height;
  End;
  WidthOk          := round(NewWidth);
  Heightok         := round(NewHeight);
  pVideo.Width     := WidthOk;
  pVideo.Height    := Heightok;
  Video.Width      := WidthOk;
  Video.Height     := Heightok;
  Detection.Width  := WidthOk;
  Detection.Height := Heightok;
  //  statusbar.SimpleText := inttostr(WidthOk) + ' x ' + inttostr(Heightok);
End;

Procedure TMain.btMoreSettingsClick(Sender: TObject);
Begin
  Video.SaveGraph(Config);
  If EditGraphConfig(Config) Then
    Try
      Video.RestoreGraph(Config);
    Finally
      //StopWait;
    End;
End;

Procedure TMain.btCloseSettingsClick(Sender: TObject);
Begin
  SetCheckDD;
  pSettings.Visible := False;
End;

Procedure TMain.VideoBitmapGrabbed(CapturedImage: TCapturedBitmap);
Var
  Bmp:      TBitmap;
  Jpg:      TJpegImage;
  NameFile: String;
Begin
  If Not MakeSingleCapture Then
  Begin
    Bmp := tbitmap.Create;
    Try
      Bmp.Assign(capturedimage);
      Detection.InsertNextBitmap(Bmp)
    Finally
      Bmp.Free
    End;
  End
  Else
  Begin
    btCaptureFrame.Enabled := False;
    MakeSingleCapture      := False;
    Jpg                    := TJPEGImage.Create;
    Try
      NameFile := FormatDateTime('yyyy-mm-dd - hh-nn-ss', Now) + '.jpg';
      Jpg.Assign(CapturedImage);
      Jpg.SaveToFile(ImgDir + NameFile);
      StatusBar.SimpleText := 'Image ' + NameFile + ' enregist.';
    Finally
      Jpg.Free;
      btCaptureFrame.Enabled := True;
    End;
  End;
End;

End.

